diff --git a/rsvg-css.c b/rsvg-css.c
index e988ce5..5b359a2 100644
--- a/rsvg-css.c
+++ b/rsvg-css.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /* 
    rsvg-css.c: Parse CSS basic data types.
  
@@ -38,6 +39,10 @@
 #include <errno.h>
 #include <math.h>
 
+#include <libxml/parser.h>
+
+#include <libcroco/libcroco.h>
+
 #define POINTS_PER_INCH (72.0)
 #define CM_PER_INCH     (2.54)
 #define MM_PER_INCH     (25.4)
@@ -47,7 +52,7 @@
 #define UNSETINHERIT() G_STMT_START {if (inherit != NULL) *inherit = FALSE;} G_STMT_END
 
 /**
- * rsvg_css_parse_vbox
+ * rsvg_css_parse_vbox:
  * @vbox: The CSS viewBox
  * @x : The X output
  * @y: The Y output
@@ -64,8 +69,8 @@ rsvg_css_parse_vbox (const char *vbox)
     guint list_len;
     vb.active = FALSE;
 
-    vb.x = vb.y = 0;
-    vb.w = vb.h = 0;
+    vb.rect.x = vb.rect.y = 0;
+    vb.rect.width = vb.rect.height = 0;
 
     list = rsvg_css_parse_number_list (vbox, &list_len);
 
@@ -75,10 +80,10 @@ rsvg_css_parse_vbox (const char *vbox)
         g_free (list);
         return vb;
     } else {
-        vb.x = list[0];
-        vb.y = list[1];
-        vb.w = list[2];
-        vb.h = list[3];
+        vb.rect.x = list[0];
+        vb.rect.y = list[1];
+        vb.rect.width = list[2];
+        vb.rect.height = list[3];
         vb.active = TRUE;
 
         g_free (list);
@@ -93,8 +98,8 @@ typedef enum _RelativeSize {
 } RelativeSize;
 
 static double
-rsvg_css_parse_raw_length (const char *str, gint * in,
-                           gint * percent, gint * em, gint * ex, RelativeSize * relative_size)
+rsvg_css_parse_raw_length (const char *str, gboolean * in,
+                           gboolean * percent, gboolean * em, gboolean * ex, RelativeSize * relative_size)
 {
     double length = 0.0;
     char *p = NULL;
@@ -177,7 +182,7 @@ RsvgLength
 _rsvg_css_parse_length (const char *str)
 {
     RsvgLength out;
-    gint percent, em, ex, in;
+    gboolean percent, em, ex, in;
     RelativeSize relative_size = RELATIVE_SIZE_NORMAL;
     percent = em = ex = in = FALSE;
 
@@ -199,6 +204,31 @@ _rsvg_css_parse_length (const char *str)
     return out;
 }
 
+/* Recursive evaluation of all parent elements regarding absolute font size */
+double
+_rsvg_css_normalize_font_size (RsvgState * state, RsvgDrawingCtx * ctx)
+{
+    RsvgState *parent;
+
+    switch (state->font_size.factor) {
+    case 'p':
+    case 'm':
+    case 'x':
+        parent = rsvg_state_parent (state);
+        if (parent) {
+            double parent_size;
+            parent_size = _rsvg_css_normalize_font_size (parent, ctx);
+            return state->font_size.length * parent_size;
+        }
+        break;
+    default:
+        return _rsvg_css_normalize_length (&state->font_size, ctx, 'v');
+        break;
+    }
+
+    return 12.;
+}
+
 double
 _rsvg_css_normalize_length (const RsvgLength * in, RsvgDrawingCtx * ctx, char dir)
 {
@@ -206,14 +236,14 @@ _rsvg_css_normalize_length (const RsvgLength * in, RsvgDrawingCtx * ctx, char di
         return in->length;
     else if (in->factor == 'p') {
         if (dir == 'h')
-            return in->length * ctx->vb.w;
+            return in->length * ctx->vb.rect.width;
         if (dir == 'v')
-            return in->length * ctx->vb.h;
+            return in->length * ctx->vb.rect.height;
         if (dir == 'o')
-            return in->length * rsvg_viewport_percentage (ctx->vb.w, ctx->vb.h);
+            return in->length * rsvg_viewport_percentage (ctx->vb.rect.width,
+                                                          ctx->vb.rect.height);
     } else if (in->factor == 'm' || in->factor == 'x') {
-        double font = _rsvg_css_hand_normalize_length (&rsvg_state_current (ctx)->font_size,
-                                                       ctx->dpi_y, ctx->vb.h, 1);
+        double font = _rsvg_css_normalize_font_size (rsvg_current_state (ctx), ctx);
         if (in->factor == 'm')
             return in->length * font;
         else
@@ -234,6 +264,27 @@ _rsvg_css_normalize_length (const RsvgLength * in, RsvgDrawingCtx * ctx, char di
     return 0;
 }
 
+/* Recursive evaluation of all parent elements regarding basline-shift */
+double
+_rsvg_css_accumulate_baseline_shift (RsvgState * state, RsvgDrawingCtx * ctx)
+{
+    RsvgState *parent;
+    double shift = 0.;
+
+    parent = rsvg_state_parent (state);
+    if (parent) {
+        if (state->has_baseline_shift) {
+            double parent_font_size;
+            parent_font_size = _rsvg_css_normalize_font_size (parent, ctx); /* font size from here */
+            shift = parent_font_size * state->baseline_shift;
+        }
+        shift += _rsvg_css_accumulate_baseline_shift (parent, ctx); /* baseline-shift for parent element */
+    }
+
+    return shift;
+}
+
+
 double
 _rsvg_css_hand_normalize_length (const RsvgLength * in, gdouble pixels_per_inch,
                                  gdouble width_or_height, gdouble font_size)
@@ -252,98 +303,36 @@ _rsvg_css_hand_normalize_length (const RsvgLength * in, gdouble pixels_per_inch,
     return 0;
 }
 
-double
-_rsvg_css_hand_normalize_length_sub (const RsvgLength * in, gdouble length, 
-				     gdouble pixels_per_inch, gdouble width_or_height, 
-				     gdouble font_size)
-{
-    if (in->factor == '\0')
-        return length;
-    else if (in->factor == 'p')
-        return length * width_or_height;
-    else if (in->factor == 'm')
-        return length * font_size;
-    else if (in->factor == 'x')
-        return length * font_size / 2.;
-    else if (in->factor == 'i')
-        return length * pixels_per_inch;
-
-    return 0;
-}
-
-gboolean
-rsvg_css_param_match (const char *str, const char *param_name)
-{
-    int i;
-
-    for (i = 0; str[i] != '\0' && param_name[i] != '\0'; i++)
-        if (param_name[i] != str[i])
-            return FALSE;
-    return str[i] == ':' && param_name[i] == '\0';
-}
-
-int
-rsvg_css_param_arg_offset (const char *str)
-{
-    int i;
-    int found;
-    found = -1;
-    i = 0;
-    while (str[i] != '\0') {
-        for (; str[i] != '\0' && str[i] != ':'; i++);
-        if (str[i] != '\0')
-            i++;
-        for (; str[i] == ' '; i++);
-        if (str[i] != '\0')
-            found = i;
-    }
-    if (found == -1)
-        found = i;
-    return found;
-}
-
 static gint
-rsvg_css_clip_rgb_percent (gdouble in_percent)
+rsvg_css_clip_rgb_percent (const char *s, double max)
 {
-    /* spec says to clip these values */
-    if (in_percent > 100.)
-        return 255;
-    else if (in_percent <= 0.)
-        return 0;
-    return (gint) floor (255. * in_percent / 100. + 0.5);
-}
-
-static gint
-rsvg_css_clip_rgb (gint rgb)
-{
-    /* spec says to clip these values */
-    if (rgb > 255)
-        return 255;
-    else if (rgb < 0)
-        return 0;
-    return rgb;
-}
-
-typedef struct {
-    const char *const name;
-    guint rgb;
-} ColorPair;
+    double value;
+    char *end;
 
-/* compare function callback for bsearch */
-static int
-rsvg_css_color_compare (const void *a, const void *b)
-{
-    const char *needle = (const char *) a;
-    const ColorPair *haystack = (const ColorPair *) b;
+    value = g_ascii_strtod (s, &end);
 
-    return g_ascii_strcasecmp (needle, haystack->name);
+    if (*end == '%') {
+        value = CLAMP (value, 0, 100) / 100.0;
+    }
+    else {
+        value = CLAMP (value, 0, max) / max;
+    }
+    
+    return (gint) floor (value * 255 + 0.5);
 }
 
 /* pack 3 [0,255] ints into one 32 bit one */
-#define PACK_RGB(r,g,b) (((r) << 16) | ((g) << 8) | (b))
+#define PACK_RGBA(r,g,b,a) (((a) << 24) | ((r) << 16) | ((g) << 8) | (b))
+#define PACK_RGB(r,g,b) PACK_RGBA(r, g, b, 255)
 
 /**
+ * rsvg_css_parse_color:
+ * @str: string to parse
+ * @inherit: whether to inherit
+ *
  * Parse a CSS2 color specifier, return RGB value
+ *
+ * Returns: and RGB value
  */
 guint32
 rsvg_css_parse_color (const char *str, gboolean * inherit)
@@ -371,224 +360,83 @@ rsvg_css_parse_color (const char *str, gboolean * inherit)
             val = ((val & 0xf00) << 8) | ((val & 0x0f0) << 4) | (val & 0x00f);
             val |= val << 4;
         }
-    }
-    /* i want to use g_str_has_prefix but it isn't in my gstrfuncs.h?? */
-    else if (strstr (str, "rgb") != NULL) {
-        gint r, g, b;
-        r = g = b = 0;
-
-        if (strstr (str, "%") != 0) {
-            guint i, nb_toks;
-            char **toks;
 
-            /* assume rgb (9%, 100%, 23%) */
-            for (i = 0; str[i] != '('; i++);
-
-            i++;
+        val |= 0xff000000; /* opaque */
+    }
+    else if (g_str_has_prefix (str, "rgb")) {
+        gint r, g, b, a;
+        gboolean has_alpha;
+        guint nb_toks;
+        char **toks;
 
-            toks = rsvg_css_parse_list (str + i, &nb_toks);
+        r = g = b = 0;
+        a = 255;
 
-            if (toks) {
-                if (nb_toks == 3) {
-                    r = rsvg_css_clip_rgb_percent (g_ascii_strtod (toks[0], NULL));
-                    g = rsvg_css_clip_rgb_percent (g_ascii_strtod (toks[1], NULL));
-                    b = rsvg_css_clip_rgb_percent (g_ascii_strtod (toks[2], NULL));
-                }
+        if (str[3] == 'a') {
+            /* "rgba" */
+            has_alpha = TRUE;
+            str += 4;
+        }
+        else {
+            /* "rgb" */
+            has_alpha = FALSE;
+            str += 3;
+        }
 
-                g_strfreev (toks);
+        str = strchr (str, '(');
+        if (str == NULL)
+          return val;
+
+        toks = rsvg_css_parse_list (str + 1, &nb_toks);
+
+        if (toks) {
+            if (nb_toks == (has_alpha ? 4 : 3)) {
+                r = rsvg_css_clip_rgb_percent (toks[0], 255.0);
+                g = rsvg_css_clip_rgb_percent (toks[1], 255.0);
+                b = rsvg_css_clip_rgb_percent (toks[2], 255.0);
+                if (has_alpha)
+                    a = rsvg_css_clip_rgb_percent (toks[3], 1.0);
+                else
+                    a = 255;
             }
-        } else {
-            /* assume "rgb (r, g, b)" */
-            if (3 == sscanf (str, " rgb ( %d , %d , %d ) ", &r, &g, &b)) {
-                r = rsvg_css_clip_rgb (r);
-                g = rsvg_css_clip_rgb (g);
-                b = rsvg_css_clip_rgb (b);
-            } else
-                r = g = b = 0;
+
+            g_strfreev (toks);
         }
 
-        val = PACK_RGB (r, g, b);
+        val = PACK_RGBA (r, g, b, a);
     } else if (!strcmp (str, "inherit"))
         UNSETINHERIT ();
     else {
-        static const ColorPair color_list[] = {
-            {"aliceblue", PACK_RGB (240, 248, 255)},
-            {"antiquewhite", PACK_RGB (250, 235, 215)},
-            {"aqua", PACK_RGB (0, 255, 255)},
-            {"aquamarine", PACK_RGB (127, 255, 212)},
-            {"azure", PACK_RGB (240, 255, 255)},
-            {"beige", PACK_RGB (245, 245, 220)},
-            {"bisque", PACK_RGB (255, 228, 196)},
-            {"black", PACK_RGB (0, 0, 0)},
-            {"blanchedalmond", PACK_RGB (255, 235, 205)},
-            {"blue", PACK_RGB (0, 0, 255)},
-            {"blueviolet", PACK_RGB (138, 43, 226)},
-            {"brown", PACK_RGB (165, 42, 42)},
-            {"burlywood", PACK_RGB (222, 184, 135)},
-            {"cadetblue", PACK_RGB (95, 158, 160)},
-            {"chartreuse", PACK_RGB (127, 255, 0)},
-            {"chocolate", PACK_RGB (210, 105, 30)},
-            {"coral", PACK_RGB (255, 127, 80)},
-            {"cornflowerblue", PACK_RGB (100, 149, 237)},
-            {"cornsilk", PACK_RGB (255, 248, 220)},
-            {"crimson", PACK_RGB (220, 20, 60)},
-            {"cyan", PACK_RGB (0, 255, 255)},
-            {"darkblue", PACK_RGB (0, 0, 139)},
-            {"darkcyan", PACK_RGB (0, 139, 139)},
-            {"darkgoldenrod", PACK_RGB (184, 132, 11)},
-            {"darkgray", PACK_RGB (169, 169, 169)},
-            {"darkgreen", PACK_RGB (0, 100, 0)},
-            {"darkgrey", PACK_RGB (169, 169, 169)},
-            {"darkkhaki", PACK_RGB (189, 183, 107)},
-            {"darkmagenta", PACK_RGB (139, 0, 139)},
-            {"darkolivegreen", PACK_RGB (85, 107, 47)},
-            {"darkorange", PACK_RGB (255, 140, 0)},
-            {"darkorchid", PACK_RGB (153, 50, 204)},
-            {"darkred", PACK_RGB (139, 0, 0)},
-            {"darksalmon", PACK_RGB (233, 150, 122)},
-            {"darkseagreen", PACK_RGB (143, 188, 143)},
-            {"darkslateblue", PACK_RGB (72, 61, 139)},
-            {"darkslategray", PACK_RGB (47, 79, 79)},
-            {"darkslategrey", PACK_RGB (47, 79, 79)},
-            {"darkturquoise", PACK_RGB (0, 206, 209)},
-            {"darkviolet", PACK_RGB (148, 0, 211)},
-            {"deeppink", PACK_RGB (255, 20, 147)},
-            {"deepskyblue", PACK_RGB (0, 191, 255)},
-            {"dimgray", PACK_RGB (105, 105, 105)},
-            {"dimgrey", PACK_RGB (105, 105, 105)},
-            {"dodgerblue", PACK_RGB (30, 144, 255)},
-            {"firebrick", PACK_RGB (178, 34, 34)},
-            {"floralwhite", PACK_RGB (255, 255, 240)},
-            {"forestgreen", PACK_RGB (34, 139, 34)},
-            {"fuchsia", PACK_RGB (255, 0, 255)},
-            {"gainsboro", PACK_RGB (220, 220, 220)},
-            {"ghostwhite", PACK_RGB (248, 248, 255)},
-            {"gold", PACK_RGB (255, 215, 0)},
-            {"goldenrod", PACK_RGB (218, 165, 32)},
-            {"gray", PACK_RGB (128, 128, 128)},
-            {"green", PACK_RGB (0, 128, 0)},
-            {"greenyellow", PACK_RGB (173, 255, 47)},
-            {"grey", PACK_RGB (128, 128, 128)},
-            {"honeydew", PACK_RGB (240, 255, 240)},
-            {"hotpink", PACK_RGB (255, 105, 180)},
-            {"indianred", PACK_RGB (205, 92, 92)},
-            {"indigo", PACK_RGB (75, 0, 130)},
-            {"ivory", PACK_RGB (255, 255, 240)},
-            {"khaki", PACK_RGB (240, 230, 140)},
-            {"lavender", PACK_RGB (230, 230, 250)},
-            {"lavenderblush", PACK_RGB (255, 240, 245)},
-            {"lawngreen", PACK_RGB (124, 252, 0)},
-            {"lemonchiffon", PACK_RGB (255, 250, 205)},
-            {"lightblue", PACK_RGB (173, 216, 230)},
-            {"lightcoral", PACK_RGB (240, 128, 128)},
-            {"lightcyan", PACK_RGB (224, 255, 255)},
-            {"lightgoldenrodyellow", PACK_RGB (250, 250, 210)},
-            {"lightgray", PACK_RGB (211, 211, 211)},
-            {"lightgreen", PACK_RGB (144, 238, 144)},
-            {"lightgrey", PACK_RGB (211, 211, 211)},
-            {"lightpink", PACK_RGB (255, 182, 193)},
-            {"lightsalmon", PACK_RGB (255, 160, 122)},
-            {"lightseagreen", PACK_RGB (32, 178, 170)},
-            {"lightskyblue", PACK_RGB (135, 206, 250)},
-            {"lightslategray", PACK_RGB (119, 136, 153)},
-            {"lightslategrey", PACK_RGB (119, 136, 153)},
-            {"lightsteelblue", PACK_RGB (176, 196, 222)},
-            {"lightyellow", PACK_RGB (255, 255, 224)},
-            {"lime", PACK_RGB (0, 255, 0)},
-            {"limegreen", PACK_RGB (50, 205, 50)},
-            {"linen", PACK_RGB (250, 240, 230)},
-            {"magenta", PACK_RGB (255, 0, 255)},
-            {"maroon", PACK_RGB (128, 0, 0)},
-            {"mediumaquamarine", PACK_RGB (102, 205, 170)},
-            {"mediumblue", PACK_RGB (0, 0, 205)},
-            {"mediumorchid", PACK_RGB (186, 85, 211)},
-            {"mediumpurple", PACK_RGB (147, 112, 219)},
-            {"mediumseagreen", PACK_RGB (60, 179, 113)},
-            {"mediumslateblue", PACK_RGB (123, 104, 238)},
-            {"mediumspringgreen", PACK_RGB (0, 250, 154)},
-            {"mediumturquoise", PACK_RGB (72, 209, 204)},
-            {"mediumvioletred", PACK_RGB (199, 21, 133)},
-            {"midnightblue", PACK_RGB (25, 25, 112)},
-            {"mintcream", PACK_RGB (245, 255, 250)},
-            {"mistyrose", PACK_RGB (255, 228, 225)},
-            {"moccasin", PACK_RGB (255, 228, 181)},
-            {"navajowhite", PACK_RGB (255, 222, 173)},
-            {"navy", PACK_RGB (0, 0, 128)},
-            {"oldlace", PACK_RGB (253, 245, 230)},
-            {"olive", PACK_RGB (128, 128, 0)},
-            {"olivedrab", PACK_RGB (107, 142, 35)},
-            {"orange", PACK_RGB (255, 165, 0)},
-            {"orangered", PACK_RGB (255, 69, 0)},
-            {"orchid", PACK_RGB (218, 112, 214)},
-            {"palegoldenrod", PACK_RGB (238, 232, 170)},
-            {"palegreen", PACK_RGB (152, 251, 152)},
-            {"paleturquoise", PACK_RGB (175, 238, 238)},
-            {"palevioletred", PACK_RGB (219, 112, 147)},
-            {"papayawhip", PACK_RGB (255, 239, 213)},
-            {"peachpuff", PACK_RGB (255, 218, 185)},
-            {"peru", PACK_RGB (205, 133, 63)},
-            {"pink", PACK_RGB (255, 192, 203)},
-            {"plum", PACK_RGB (221, 160, 203)},
-            {"powderblue", PACK_RGB (176, 224, 230)},
-            {"purple", PACK_RGB (128, 0, 128)},
-            {"red", PACK_RGB (255, 0, 0)},
-            {"rosybrown", PACK_RGB (188, 143, 143)},
-            {"royalblue", PACK_RGB (65, 105, 225)},
-            {"saddlebrown", PACK_RGB (139, 69, 19)},
-            {"salmon", PACK_RGB (250, 128, 114)},
-            {"sandybrown", PACK_RGB (244, 164, 96)},
-            {"seagreen", PACK_RGB (46, 139, 87)},
-            {"seashell", PACK_RGB (255, 245, 238)},
-            {"sienna", PACK_RGB (160, 82, 45)},
-            {"silver", PACK_RGB (192, 192, 192)},
-            {"skyblue", PACK_RGB (135, 206, 235)},
-            {"slateblue", PACK_RGB (106, 90, 205)},
-            {"slategray", PACK_RGB (119, 128, 144)},
-            {"slategrey", PACK_RGB (119, 128, 144)},
-            {"snow", PACK_RGB (255, 255, 250)},
-            {"springgreen", PACK_RGB (0, 255, 127)},
-            {"steelblue", PACK_RGB (70, 130, 180)},
-            {"tan", PACK_RGB (210, 180, 140)},
-            {"teal", PACK_RGB (0, 128, 128)},
-            {"thistle", PACK_RGB (216, 191, 216)},
-            {"tomato", PACK_RGB (255, 99, 71)},
-            {"turquoise", PACK_RGB (64, 224, 208)},
-            {"violet", PACK_RGB (238, 130, 238)},
-            {"wheat", PACK_RGB (245, 222, 179)},
-            {"white", PACK_RGB (255, 255, 255)},
-            {"whitesmoke", PACK_RGB (245, 245, 245)},
-            {"yellow", PACK_RGB (255, 255, 0)},
-            {"yellowgreen", PACK_RGB (154, 205, 50)}
-        };
-
-        ColorPair *result = bsearch (str, color_list,
-                                     sizeof (color_list) / sizeof (color_list[0]),
-                                     sizeof (ColorPair),
-                                     rsvg_css_color_compare);
-
-        /* default to black on failed lookup */
-        if (result == NULL) {
+        CRRgb rgb;
+
+        if (cr_rgb_set_from_name (&rgb, (const guchar *) str) == CR_OK) {
+            val = PACK_RGB (rgb.red, rgb.green, rgb.blue);
+        } else {
+            /* default to opaque black on failed lookup */
             UNSETINHERIT ();
-            val = 0;
-        } else
-            val = result->rgb;
+            val = PACK_RGB (0, 0, 0);
+        }
     }
 
     return val;
 }
 
 #undef PACK_RGB
+#undef PACK_RGBA
 
 guint
 rsvg_css_parse_opacity (const char *str)
 {
-    char *end_ptr;
+    char *end_ptr = NULL;
     double opacity;
 
     opacity = g_ascii_strtod (str, &end_ptr);
 
-    if (end_ptr && end_ptr[0] == '%')
-        opacity *= 0.01;
+    if (((opacity == -HUGE_VAL || opacity == HUGE_VAL) && (ERANGE == errno)) ||
+        *end_ptr != '\0')
+        opacity = 1.;
+
+    opacity = CLAMP (opacity, 0., 1.);
 
     return (guint) floor (opacity * 255. + 0.5);
 }
@@ -693,7 +541,9 @@ rsvg_css_parse_font_style (const char *str, gboolean * inherit)
             return PANGO_STYLE_OBLIQUE;
         if (!strcmp (str, "italic"))
             return PANGO_STYLE_ITALIC;
-        else if (!strcmp (str, "inherit")) {
+        if (!strcmp (str, "normal"))
+            return PANGO_STYLE_NORMAL;
+        if (!strcmp (str, "inherit")) {
             UNSETINHERIT ();
             return PANGO_STYLE_NORMAL;
         }
